~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-5.2.21)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # link vmlinux                                      4 # link vmlinux
  5 #                                                   5 #
  6 # vmlinux is linked from the objects in vmlinu !!   6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
  7 # vmlinux.a contains objects that are linked u !!   7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
                                                   >>   8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar      9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
  9 # (not within --whole-archive), and do not req     10 # (not within --whole-archive), and do not require symbol indexes added.
 10 #                                                  11 #
 11 # vmlinux                                          12 # vmlinux
 12 #   ^                                              13 #   ^
 13 #   |                                              14 #   |
 14 #   +--< vmlinux.a                             !!  15 #   +--< $(KBUILD_VMLINUX_OBJS)
                                                   >>  16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
 15 #   |                                              17 #   |
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                    18 #   +--< $(KBUILD_VMLINUX_LIBS)
 17 #   |    +--< lib/lib.a + more                     19 #   |    +--< lib/lib.a + more
 18 #   |                                              20 #   |
 19 #   +-< ${kallsymso} (see description in KALLS     21 #   +-< ${kallsymso} (see description in KALLSYMS section)
 20 #                                                  22 #
 21 # vmlinux version (uname -v) cannot be updated     23 # vmlinux version (uname -v) cannot be updated during normal
 22 # descending-into-subdirs phase since we do no     24 # descending-into-subdirs phase since we do not yet know if we need to
 23 # update vmlinux.                                  25 # update vmlinux.
 24 # Therefore this step is delayed until just be     26 # Therefore this step is delayed until just before final link of vmlinux.
 25 #                                                  27 #
 26 # System.map is generated to document addresse     28 # System.map is generated to document addresses of all kernel symbols
 27                                                    29 
 28 # Error out on error                               30 # Error out on error
 29 set -e                                             31 set -e
 30                                                    32 
 31 LD="$1"                                        << 
 32 KBUILD_LDFLAGS="$2"                            << 
 33 LDFLAGS_vmlinux="$3"                           << 
 34                                                << 
 35 is_enabled() {                                 << 
 36         grep -q "^$1=y" include/config/auto.co << 
 37 }                                              << 
 38                                                << 
 39 # Nice output in kbuild format                     33 # Nice output in kbuild format
 40 # Will be supressed by "make -s"                   34 # Will be supressed by "make -s"
 41 info()                                             35 info()
 42 {                                                  36 {
 43         printf "  %-7s %s\n" "${1}" "${2}"     !!  37         if [ "${quiet}" != "silent_" ]; then
                                                   >>  38                 printf "  %-7s %s\n" "${1}" "${2}"
                                                   >>  39         fi
 44 }                                                  40 }
 45                                                    41 
 46 # Link of vmlinux                              !!  42 # Link of vmlinux.o used for section mismatch analysis
 47 # ${1} - output file                           !!  43 # ${1} output file
 48 vmlinux_link()                                 !!  44 modpost_link()
 49 {                                                  45 {
 50         local output=${1}                      !!  46         local objects
 51         local objs                             << 
 52         local libs                             << 
 53         local ld                               << 
 54         local ldflags                          << 
 55         local ldlibs                           << 
 56                                                << 
 57         info LD ${output}                      << 
 58                                                << 
 59         # skip output file argument            << 
 60         shift                                  << 
 61                                                << 
 62         if is_enabled CONFIG_LTO_CLANG || is_e << 
 63                 # Use vmlinux.o instead of per << 
 64                 objs=vmlinux.o                 << 
 65                 libs=                          << 
 66         else                                   << 
 67                 objs=vmlinux.a                 << 
 68                 libs="${KBUILD_VMLINUX_LIBS}"  << 
 69         fi                                     << 
 70                                                    47 
 71         if is_enabled CONFIG_MODULES; then     !!  48         objects="--whole-archive                                \
 72                 objs="${objs} .vmlinux.export. !!  49                 ${KBUILD_VMLINUX_OBJS}                          \
 73         fi                                     !!  50                 --no-whole-archive                              \
 74                                                !!  51                 --start-group                                   \
 75         objs="${objs} init/version-timestamp.o !!  52                 ${KBUILD_VMLINUX_LIBS}                          \
                                                   >>  53                 --end-group"
 76                                                    54 
 77         if [ "${SRCARCH}" = "um" ]; then       !!  55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
 78                 wl=-Wl,                        !!  56 }
 79                 ld="${CC}"                     << 
 80                 ldflags="${CFLAGS_vmlinux}"    << 
 81                 ldlibs="-lutil -lrt -lpthread" << 
 82         else                                   << 
 83                 wl=                            << 
 84                 ld="${LD}"                     << 
 85                 ldflags="${KBUILD_LDFLAGS} ${L << 
 86                 ldlibs=                        << 
 87         fi                                     << 
 88                                                    57 
 89         ldflags="${ldflags} ${wl}--script=${ob !!  58 # Link of vmlinux
                                                   >>  59 # ${1} - optional extra .o files
                                                   >>  60 # ${2} - output file
                                                   >>  61 vmlinux_link()
                                                   >>  62 {
                                                   >>  63         local lds="${objtree}/${KBUILD_LDS}"
                                                   >>  64         local objects
 90                                                    65 
 91         # The kallsyms linking does not need d !!  66         if [ "${SRCARCH}" != "um" ]; then
 92         if [ -n "${strip_debug}" ] ; then      !!  67                 objects="--whole-archive                        \
 93                 ldflags="${ldflags} ${wl}--str !!  68                         ${KBUILD_VMLINUX_OBJS}                  \
 94         fi                                     !!  69                         --no-whole-archive                      \
                                                   >>  70                         --start-group                           \
                                                   >>  71                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >>  72                         --end-group                             \
                                                   >>  73                         ${1}"
 95                                                    74 
 96         if is_enabled CONFIG_VMLINUX_MAP; then !!  75                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}      \
 97                 ldflags="${ldflags} ${wl}-Map= !!  76                         -T ${lds} ${objects}
                                                   >>  77         else
                                                   >>  78                 objects="-Wl,--whole-archive                    \
                                                   >>  79                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >>  80                         -Wl,--no-whole-archive                  \
                                                   >>  81                         -Wl,--start-group                       \
                                                   >>  82                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >>  83                         -Wl,--end-group                         \
                                                   >>  84                         ${1}"
                                                   >>  85 
                                                   >>  86                 ${CC} ${CFLAGS_vmlinux} -o ${2}                 \
                                                   >>  87                         -Wl,-T,${lds}                           \
                                                   >>  88                         ${objects}                              \
                                                   >>  89                         -lutil -lrt -lpthread
                                                   >>  90                 rm -f linux
 98         fi                                         91         fi
 99                                                << 
100         ${ld} ${ldflags} -o ${output}          << 
101                 ${wl}--whole-archive ${objs} $ << 
102                 ${wl}--start-group ${libs} ${w << 
103                 ${kallsymso} ${btf_vmlinux_bin << 
104 }                                                  92 }
105                                                    93 
106 # generate .BTF typeinfo from DWARF debuginfo      94 # generate .BTF typeinfo from DWARF debuginfo
107 # ${1} - vmlinux image                         << 
108 gen_btf()                                          95 gen_btf()
109 {                                                  96 {
110         local pahole_ver                       !!  97         local pahole_ver;
111         local btf_data=${1}.btf.o              << 
112                                                    98 
113         if ! [ -x "$(command -v ${PAHOLE})" ];     99         if ! [ -x "$(command -v ${PAHOLE})" ]; then
114                 echo >&2 "BTF: ${1}: pahole ($ !! 100                 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
115                 return 1                       !! 101                 return 0
116         fi                                        102         fi
117                                                   103 
118         pahole_ver=$(${PAHOLE} --version | sed    104         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
119         if [ "${pahole_ver}" -lt "116" ]; then !! 105         if [ "${pahole_ver}" -lt "113" ]; then
120                 echo >&2 "BTF: ${1}: pahole ve !! 106                 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
121                 return 1                       !! 107                 return 0
122         fi                                     << 
123                                                << 
124         info BTF "${btf_data}"                 << 
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J << 
126                                                << 
127         # Create ${btf_data} which contains ju << 
128         # SHF_ALLOC because .BTF will be part  << 
129         # deletes all symbols including __star << 
130         # be redefined in the linker script. A << 
131         # objcopy warnings: "empty loadable se << 
132         ${OBJCOPY} --only-section=.BTF --set-s << 
133                 --strip-all ${1} "${btf_data}" << 
134         # Change e_type to ET_REL so that it c << 
135         # GNU ld 2.35+ and lld do not allow an << 
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t << 
137                 et_rel='\0\1'                  << 
138         else                                   << 
139                 et_rel='\1\0'                  << 
140         fi                                        108         fi
141         printf "${et_rel}" | dd of="${btf_data << 
142                                                   109 
143         btf_vmlinux_bin_o=${btf_data}          !! 110         info "BTF" ${1}
                                                   >> 111         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
144 }                                                 112 }
145                                                   113 
146 # Create ${2}.o file with all symbols from the !! 114 # Create ${2} .o file with all symbols from the ${1} object file
147 kallsyms()                                        115 kallsyms()
148 {                                                 116 {
                                                   >> 117         info KSYM ${2}
149         local kallsymopt;                         118         local kallsymopt;
150                                                   119 
151         if is_enabled CONFIG_KALLSYMS_ALL; the !! 120         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
152                 kallsymopt="${kallsymopt} --al    121                 kallsymopt="${kallsymopt} --all-symbols"
153         fi                                        122         fi
154                                                   123 
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE !! 124         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
156                 kallsymopt="${kallsymopt} --ab    125                 kallsymopt="${kallsymopt} --absolute-percpu"
157         fi                                        126         fi
158                                                   127 
159         info KSYMS "${2}.S"                    !! 128         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160         scripts/kallsyms ${kallsymopt} "${1}"  !! 129                 kallsymopt="${kallsymopt} --base-relative"
                                                   >> 130         fi
161                                                   131 
162         info AS "${2}.o"                       !! 132         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE !! 133                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS << 
165                                                   134 
166         kallsymso=${2}.o                       !! 135         local afile="`basename ${2} .o`.S"
167 }                                              << 
168                                                   136 
169 # Perform kallsyms for the given temporary vml !! 137         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
170 sysmap_and_kallsyms()                          !! 138         ${CC} ${aflags} -c -o ${2} ${afile}
171 {                                              << 
172         mksysmap "${1}" "${1}.syms"            << 
173         kallsyms "${1}.syms" "${1}.kallsyms"   << 
174                                                << 
175         kallsyms_sysmap=${1}.syms              << 
176 }                                                 139 }
177                                                   140 
178 # Create map file with all symbols from ${1}      141 # Create map file with all symbols from ${1}
179 # See mksymap for additional details              142 # See mksymap for additional details
180 mksysmap()                                        143 mksysmap()
181 {                                                 144 {
182         info NM ${2}                           !! 145         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
183         ${NM} -n "${1}" | sed -f "${srctree}/s << 
184 }                                                 146 }
185                                                   147 
186 sorttable()                                    !! 148 sortextable()
187 {                                                 149 {
188         ${objtree}/scripts/sorttable ${1}      !! 150         ${objtree}/scripts/sortextable ${1}
189 }                                                 151 }
190                                                   152 
                                                   >> 153 # Delete output files in case of error
191 cleanup()                                         154 cleanup()
192 {                                                 155 {
193         rm -f .btf.*                           !! 156         rm -f .tmp_System.map
                                                   >> 157         rm -f .tmp_kallsyms*
                                                   >> 158         rm -f .tmp_vmlinux*
194         rm -f System.map                          159         rm -f System.map
195         rm -f vmlinux                             160         rm -f vmlinux
196         rm -f vmlinux.map                      !! 161         rm -f vmlinux.o
197 }                                                 162 }
198                                                   163 
                                                   >> 164 on_exit()
                                                   >> 165 {
                                                   >> 166         if [ $? -ne 0 ]; then
                                                   >> 167                 cleanup
                                                   >> 168         fi
                                                   >> 169 }
                                                   >> 170 trap on_exit EXIT
                                                   >> 171 
                                                   >> 172 on_signals()
                                                   >> 173 {
                                                   >> 174         exit 1
                                                   >> 175 }
                                                   >> 176 trap on_signals HUP INT QUIT TERM
                                                   >> 177 
                                                   >> 178 #
                                                   >> 179 #
199 # Use "make V=1" to debug this script             180 # Use "make V=1" to debug this script
200 case "${KBUILD_VERBOSE}" in                       181 case "${KBUILD_VERBOSE}" in
201 *1*)                                              182 *1*)
202         set -x                                    183         set -x
203         ;;                                        184         ;;
204 esac                                              185 esac
205                                                   186 
206 if [ "$1" = "clean" ]; then                       187 if [ "$1" = "clean" ]; then
207         cleanup                                   188         cleanup
208         exit 0                                    189         exit 0
209 fi                                                190 fi
210                                                   191 
211 ${MAKE} -f "${srctree}/scripts/Makefile.build" !! 192 # We need access to CONFIG_ symbols
212                                                !! 193 . include/config/auto.conf
213 btf_vmlinux_bin_o=                             << 
214 kallsymso=                                     << 
215 strip_debug=                                   << 
216                                                << 
217 if is_enabled CONFIG_KALLSYMS; then            << 
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy << 
219         kallsyms .tmp_vmlinux.kallsyms0.syms . << 
220 fi                                             << 
221                                                << 
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO << 
223                                                << 
224         # The kallsyms linking does not need d << 
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF; << 
226                 strip_debug=1                  << 
227         fi                                     << 
228                                                << 
229         vmlinux_link .tmp_vmlinux1             << 
230 fi                                             << 
231                                                << 
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then      << 
233         if ! gen_btf .tmp_vmlinux1; then       << 
234                 echo >&2 "Failed to generate B << 
235                 echo >&2 "Try to disable CONFI << 
236                 exit 1                         << 
237         fi                                     << 
238 fi                                             << 
239                                                   194 
240 if is_enabled CONFIG_KALLSYMS; then            !! 195 # Update version
                                                   >> 196 info GEN .version
                                                   >> 197 if [ -r .version ]; then
                                                   >> 198         VERSION=$(expr 0$(cat .version) + 1)
                                                   >> 199         echo $VERSION > .version
                                                   >> 200 else
                                                   >> 201         rm -f .version
                                                   >> 202         echo 1 > .version
                                                   >> 203 fi;
                                                   >> 204 
                                                   >> 205 # final build of init/
                                                   >> 206 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
                                                   >> 207 
                                                   >> 208 #link vmlinux.o
                                                   >> 209 info LD vmlinux.o
                                                   >> 210 modpost_link vmlinux.o
                                                   >> 211 
                                                   >> 212 # modpost vmlinux.o to check for section mismatches
                                                   >> 213 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
                                                   >> 214 
                                                   >> 215 info MODINFO modules.builtin.modinfo
                                                   >> 216 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
                                                   >> 217 
                                                   >> 218 kallsymso=""
                                                   >> 219 kallsyms_vmlinux=""
                                                   >> 220 if [ -n "${CONFIG_KALLSYMS}" ]; then
241                                                   221 
242         # kallsyms support                        222         # kallsyms support
243         # Generate section listing all symbols    223         # Generate section listing all symbols and add it into vmlinux
244         # It's a four step process:            !! 224         # It's a three step process:
245         # 0)  Generate a dummy __kallsyms with !! 225         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i !! 226         #     but __kallsyms is empty.
247         #     with a dummy __kallsyms.         << 
248         #     Running kallsyms on that gives u    227         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
249         #     the right size                      228         #     the right size
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i !! 229         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
251         #     the right size, but due to the a    230         #     the right size, but due to the added section, some
252         #     addresses have shifted.             231         #     addresses have shifted.
253         #     From here, we generate a correct !! 232         #     From here, we generate a correct .tmp_kallsyms2.o
254         # 3)  That link may have expanded the     233         # 3)  That link may have expanded the kernel image enough that
255         #     more linker branch stubs / tramp    234         #     more linker branch stubs / trampolines had to be added, which
256         #     introduces new names, which furt    235         #     introduces new names, which further expands kallsyms. Do another
257         #     pass if that is the case. In the    236         #     pass if that is the case. In theory it's possible this results
258         #     in even more stubs, but unlikely    237         #     in even more stubs, but unlikely.
259         #     KALLSYMS_EXTRA_PASS=1 may also u    238         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
260         #     other bugs.                         239         #     other bugs.
261         # 4)  The correct ${kallsymso} is link    240         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
262         #                                         241         #
263         # a)  Verify that the System.map from     242         # a)  Verify that the System.map from vmlinux matches the map from
264         #     ${kallsymso}.                       243         #     ${kallsymso}.
265                                                   244 
266         # The kallsyms linking does not need d !! 245         kallsymso=.tmp_kallsyms2.o
267         strip_debug=1                          !! 246         kallsyms_vmlinux=.tmp_vmlinux2
268                                                   247 
269         sysmap_and_kallsyms .tmp_vmlinux1      !! 248         # step 1
270         size1=$(${CONFIG_SHELL} "${srctree}/sc !! 249         vmlinux_link "" .tmp_vmlinux1
271                                                !! 250         kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
272         vmlinux_link .tmp_vmlinux2             !! 251 
273         sysmap_and_kallsyms .tmp_vmlinux2      !! 252         # step 2
274         size2=$(${CONFIG_SHELL} "${srctree}/sc !! 253         vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
                                                   >> 254         kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
                                                   >> 255 
                                                   >> 256         # step 3
                                                   >> 257         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
                                                   >> 258         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
275                                                   259 
276         if [ $size1 -ne $size2 ] || [ -n "${KA    260         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277                 vmlinux_link .tmp_vmlinux3     !! 261                 kallsymso=.tmp_kallsyms3.o
278                 sysmap_and_kallsyms .tmp_vmlin !! 262                 kallsyms_vmlinux=.tmp_vmlinux3
                                                   >> 263 
                                                   >> 264                 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
                                                   >> 265 
                                                   >> 266                 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
279         fi                                        267         fi
280 fi                                                268 fi
281                                                   269 
282 strip_debug=                                   !! 270 info LD vmlinux
                                                   >> 271 vmlinux_link "${kallsymso}" vmlinux
283                                                   272 
284 vmlinux_link vmlinux                           !! 273 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
                                                   >> 274         gen_btf vmlinux
                                                   >> 275 fi
285                                                   276 
286 # fill in BTF IDs                              !! 277 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab !! 278         info SORTEX vmlinux
288         info BTFIDS vmlinux                    !! 279         sortextable vmlinux
289         ${RESOLVE_BTFIDS} vmlinux              << 
290 fi                                                280 fi
291                                                   281 
                                                   >> 282 info SYSMAP System.map
292 mksysmap vmlinux System.map                       283 mksysmap vmlinux System.map
293                                                   284 
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the << 
295         info SORTTAB vmlinux                   << 
296         if ! sorttable vmlinux; then           << 
297                 echo >&2 Failed to sort kernel << 
298                 exit 1                         << 
299         fi                                     << 
300 fi                                             << 
301                                                << 
302 # step a (see comment above)                      285 # step a (see comment above)
303 if is_enabled CONFIG_KALLSYMS; then            !! 286 if [ -n "${CONFIG_KALLSYMS}" ]; then
304         if ! cmp -s System.map "${kallsyms_sys !! 287         mksysmap ${kallsyms_vmlinux} .tmp_System.map
                                                   >> 288 
                                                   >> 289         if ! cmp -s System.map .tmp_System.map; then
305                 echo >&2 Inconsistent kallsyms    290                 echo >&2 Inconsistent kallsyms data
306                 echo >&2 'Try "make KALLSYMS_E !! 291                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
307                 exit 1                            292                 exit 1
308         fi                                        293         fi
309 fi                                                294 fi
310                                                << 
311 # For fixdep                                   << 
312 echo "vmlinux: $0" > .vmlinux.d                << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php